WInS_Demos/coherence-examples/coherence-web-examples/coherence-web-split-storage/src/main/java/beans/SessionController.java
package beans;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.servlet.http.HttpSession;
import java.io.Serializable;
import java.util.*;
import java.util.logging.Logger;

/**
  * **************************************************************************
 * <p/>
 * This code is provided for example purposes only.  Oracle does not assume
 * any responsibility or liability for the consequences of using this code.
 * If you choose to use this code for any reason, including but not limited
 * to its use as an example you do so at your own risk and without the support
 * of Oracle.
 *
 * This code is provided under the following licenses:
 *
 * GNU General Public License (GPL-2.0)
 * COMMON DEVELOPMENT AND DISTRIBUTION LICENSE Version 1.0 (CDDL-1.0)
 *
 * <p/>
 * ****************************************************************************
 * User: jeffrey.a.west
 * Date: Jul 27, 2011
 * Time: 10:06:52 AM
 */

@ManagedBean
@SessionScoped
public class SessionController implements Serializable
{
  static final long serialVersionUID = 43L;
  private static final Logger logger = Logger.getLogger(SessionController.class.getName());
  private String inputKeyName;
  private String inputArrayLength;

  public SessionController()
  {
  }

  public void removeSelectedAttribute(ActionEvent pEvent)
  {

  }


  public void removeEntry(String pKey)
  {
    getSession().removeAttribute(pKey);
  }

  public void addNewEntry()
  {
    int value = 0;

    try
    {
      value = Integer.parseInt(inputArrayLength);
      getSession().setAttribute(inputKeyName, getIntegerArray(value));
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }

    inputKeyName = "";
    inputArrayLength = "";
  }

  private int[] getIntegerArray(int size)
  {
    int[] array = new int[size];
    for (int x = 0; x < size; x++)
    {
      array[x] = x;
    }
    return array;
  }

  public String getInputKeyName()
  {
    return inputKeyName;
  }

  public void setInputKeyName(String inputKeyName)
  {
    this.inputKeyName = inputKeyName;
  }

  public String getInputArrayLength()
  {
    return inputArrayLength;
  }

  public void setInputArrayLength(String inputArrayLength)
  {
    this.inputArrayLength = inputArrayLength;
  }

  public HttpSession getSession()
  {
    return (HttpSession) getFacesContext().getExternalContext().getSession(true);
  }

  public String getSessionId()
  {
    return getSession().getId();
  }

  public String getWebLogicServerName()
  {
    return System.getProperty("weblogic.Name");
  }

  public FacesContext getFacesContext()
  {
    FacesContext ctx = FacesContext.getCurrentInstance();

    //ctx.get

    return ctx;
  }


  public List<Map.Entry> getSessionAttributes()
  {
    List<Map.Entry> atts = new ArrayList();

    Enumeration<String> attributes = getSession().getAttributeNames();

    //logger.info("Session Attributes:");
    //logger.info("======================================");
    while (attributes.hasMoreElements())
    {
      String att = attributes.nextElement();

      if (att.equals("com.sun.faces.renderkit.ServerSideStateHelper.LogicalViewMap")
          || att.equals("javax.faces.request.charset"))
      {
        continue;
      }

      Object value = getSession().getAttribute(att);
      atts.add(new AbstractMap.SimpleEntry(att, value));
      //logger.info("Att name=[" + att + "] ObjectType=[" + value.getClass() + "] value=[" + value + "]");
    }
    //logger.info("======================================");

    return atts;
  }

  public String invalidateSession()
  {
    invalidate();
    return "/index";
  }

  public void invalidateSessionListener(ActionEvent event)
  {
    invalidate();
  }

  private void invalidate()
  {
    logger.info("INVALIDATING SESSION!! ID=[" + getSessionId() + "]");

    getSession().invalidate();
  }


  public void invalidateSessionActionListener(ActionEvent event)
  {
    invalidateSession();
    getFacesContext().addMessage(null, new FacesMessage("Session Invalidated", "User Request"));
  }


}

WInS_Demos/coherence-examples/coherence-web-examples/coherence-web-split-storage/src/main/java/Controller.java
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;
import java.io.Serializable;
import java.lang.instrument.Instrumentation;

/**
 * Created by IntelliJ IDEA.
 * User: jeffrey.a.west
 * Date: 3/28/12
 * Time: 4:27 PM
 */
@Named(value = "Controller")
@SessionScoped
public class Controller implements Serializable
{
  public String showMessage()
  {

    System.out.println("SHOWMESSAGE");
    return "showMessage";
  }
}

WInS_Demos/coherence-examples/coherence-web-examples/coherence-web-split-storage/src/main/webapp/index.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:p="http://primefaces.org/ui"
      xmlns:f="http://java.sun.com/jsf/core"
    >
<h:head>

</h:head>
<h:body>

  <ui:composition template="/templates/common/layout.xhtml">

    <ui:define name="content">


      <h:form id="frm1" prependId="false">
        <p:growl showDetail="true"/>


        <p:panel header="New Attribute">
          <h:panelGrid columns="2">
            <h:outputLabel value="Key :"
                           for="txt_key"/>

            <p:inputText id="txt_key"
                         value="#{sessionController.inputKeyName}"
                         required="true"
                         label="Key"/>

            <h:outputLabel value="Integer Array Length :"
                           for="txt_arrlen"/>

            <p:inputText id="txt_arrlen"
                         value="#{sessionController.inputArrayLength}"
                         required="true"
                         label="ArrayLen"/>
          </h:panelGrid>

          <p:commandButton value="Add Session Attribute"
                           actionListener="#{sessionController.addNewEntry}"
                           update="tblAttributes"/>

        </p:panel>

        <br/>

        <p:panel id="atts" header="Current Session Attributes">
          <p:commandButton value="Refresh"
                           update="tblAttributes"/>

          <p:commandButton value="Invalidate Session"
                           process="@this"
                           update="frm1"
                           actionListener="#{sessionController.invalidateSessionListener}"/>

          <br/>

          <div id="session_id" class="session_id_header">
            <h:outputText value="Server: #{sessionController.webLogicServerName}"/>
            <br/>
            <h:outputText value="Session ID: #{sessionController.sessionId}"/>
          </div>

          <p:dataTable value="#{sessionController.sessionAttributes}"
                       id="tblAttributes"
                       var="att"
                       styleClass="data-table"
                       headerClass="table-header"
                       rowClasses="row-odd,row-even">

            <f:facet name="header">Session Attributes</f:facet>

            <p:column>
              <f:facet name="header">Remove</f:facet>
              <p:commandLink value="Remove"/>
            </p:column>

            <p:column>
              <f:facet name="header">Key</f:facet>
              <h:outputText value="#{att.key}"/>
            </p:column>

            <p:column>
              <f:facet name="header">Value</f:facet>
              <h:outputText value="#{att.value}"/>
            </p:column>

          </p:dataTable>
        </p:panel>

      </h:form>
    </ui:define>

  </ui:composition>
</h:body>

</html>

WInS_Demos/coherence-examples/coherence-web-examples/coherence-web-split-storage/src/main/webapp/session/sessionHome.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html
    PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:p="http://primefaces.prime.com.tr/ui"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:f="http://java.sun.com/jsf/core"
      xml:lang="en" lang="en">

<h:head>
  <h:outputStylesheet name="main.css" library="css"/>
  <h:outputStylesheet name="styles.css" library="css"/>
</h:head>

<h:body>

  <ui:composition template="/templates/common/layout.xhtml">

    <ui:define name="content">
      <p:panel header="Session Information">
        <h:outputText value="Server: "/>
        <h:outputText value="#{SessionControllerBean.webLogicServerName}"/>
        <br/>

        <h:outputText value="Session ID: "/>
        <h:outputText value="#{SessionControllerBean.sessionId}"/>
        <br/>

        <h:form>
          <h:commandButton value="Invalidate Session"
                           action="#{SessionControllerBean.invalidateSession}">
          </h:commandButton>
        </h:form>

        <h:dataTable value="#{SessionControllerBean.sessionAttributes}"
                     var="att"
                     styleClass="data-table"
                     headerClass="table-header"
                     rowClasses="row-odd,row-even">

          <f:facet name="header">Session Attributes</f:facet>

          <h:column>
            <f:facet name="header">Key</f:facet>
            <h:outputText value="#{att.key}"/>
          </h:column>

          <h:column>
            <f:facet name="header">Value Class</f:facet>
            <h:outputText value="#{att.value.class}"/>
          </h:column>

          <h:column>
            <f:facet name="header">Value</f:facet>
            <h:outputText value="#{att.value}"/>
          </h:column>

        </h:dataTable>

      </p:panel>
    </ui:define>

  </ui:composition>

</h:body>
</html>

WInS_Demos/coherence-examples/coherence-web-examples/coherence-web-split-storage/src/main/webapp/templates/common/content.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:p="http://primefaces.org/ui"
      xmlns:ui="http://java.sun.com/jsf/facelets"
    >
<body>
<ui:composition>

  default content

</ui:composition>
</body>
</html>

WInS_Demos/coherence-examples/coherence-web-examples/coherence-web-split-storage/src/main/webapp/templates/common/footer.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:p="http://primefaces.org/ui"
      xmlns:h="http://java.sun.com/jsf/html">
<body>
<ui:composition>

  <hr/>
  <div id="copyright" class="copyright">Copyright 2012 - Oracle Corporation</div>
  <div id="disclaimer" class="disclaimer">This code and application are for example purposes only</div>
  <br/>

</ui:composition>
</body>
</html>

WInS_Demos/coherence-examples/coherence-web-examples/coherence-web-split-storage/src/main/webapp/templates/common/header.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:p="http://primefaces.org/ui"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
    >
<h:body>
  <ui:composition>

    <h2>Example App for Coherence Web</h2>


    <hr/>
  </ui:composition>
</h:body>
</html>

WInS_Demos/coherence-examples/coherence-web-examples/coherence-web-split-storage/src/main/webapp/templates/common/layout.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:ui="http://java.sun.com/jsf/facelets"
    >

<h:head>
  <h:outputStylesheet name="main.css" library="css"/>
</h:head>

<h:body>

  <div id="page">

    <div id="header">
      <ui:insert name="header" class="header">
        <ui:include src="/templates/common/header.xhtml"/>
      </ui:insert>
    </div>

    <div id="content" class="content">
      <ui:insert name="content"/>
    </div>

    <div id="footer" class="footer">
      <ui:insert name="footer">
        <ui:include src="/templates/common/footer.xhtml"/>
      </ui:insert>
    </div>

  </div>

</h:body>
</html>